# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (c) 2010 AvanzOsc S.L. (http://avanzosc.com) All Rights Reserved.
#                       Ana Juaristi <anajuaristi@avanzosc.com>
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv,orm
import xmlrpclib


class esale_oscom_extra_fields(osv.osv):
    _name = "esale.oscom.extra_fields"
    _columns = {
        'name': fields.char('Name', size=64, required=True),
        'web_id': fields.many2one('esale.oscom.web', 'Website'),
        'esale_oscom_id': fields.integer('Extra field osc id'),
        'order': fields.integer('Order'),
        'status': fields.integer('Status'),
        'language_id': fields.integer('Language'),
    }
esale_oscom_extra_fields()

class esale_oscom_products_extra_fields(osv.osv):
    _inherit = 'product.product'
    _columns = {
        'product_extra_field_ids': fields.one2many('esale.oscom.product.extra_fields_values', 'products_id', 'Product extra fields'),
    }
        
esale_oscom_products_extra_fields()

class esale_oscom_products_extra_fields_values(osv.osv):

    _name = "esale.oscom.product.extra_fields_values"

    _columns = {
        'name': fields.char('Name', size=64),
        'web_id': fields.many2one('esale.oscom.web', 'Website'),
        'products_id': fields.many2one('product.product', 'Product'),
        'extra_field_id': fields.many2one('esale.oscom.extra_fields', 'Product extra fields'),
        'extra_fields_value': fields.text('extra field value'),
    }
        
esale_oscom_products_extra_fields_values()

class esale_oscom_web(osv.osv):
    _inherit = 'esale.oscom.web'

    def extra_fields_import(self, cr, uid, ids, *args):
        esale_extra_fields_obj = self.pool.get('esale.oscom.extra_fields')
        print "imprimiendo extra_fields openerp", esale_extra_fields_obj
        for website in self.browse(cr, uid, ids):
            server = xmlrpclib.ServerProxy("%s/openerp-synchro.php" % website.url)
            extra_fields = server.get_extra_fields()
            print extra_fields
            for extra_field in extra_fields:
                value = {
                    'web_id' : website.id,
                    'esale_oscom_id' : extra_field[0],
                    'name': extra_field[1],
                    'order' : extra_field[2],
                    'status': extra_field[3],
                    'language_id': extra_field[4],
                }
                print extra_field
                print extra_field[0]
                existing = esale_extra_fields_obj.search(cr, uid, [('web_id','=',website.id), ('esale_oscom_id', '=', extra_field[0])])
                if len(existing) > 0:
                    print "Existen campos extra", existing
                    esale_extra_fields_obj.write(cr, uid, existing, value)
                else:
                    print "NO Existen campos extra", existing
                    esale_extra_fields_obj.create(cr, uid, value)
        return True
 
    def product_extra_info_extra_fields(self, cr, uid, website, prod_id, prod_data):
        esale_products_extra_fields_obj = self.pool.get('esale.oscom.product.extra_fields_values')
        esale_extra_fields_obj = self.pool.get('esale.oscom.extra_fields')
        
        print "imprimiendo product extra_fields openerp", esale_products_extra_fields_obj
        info_prod = prod_data['product']
        server = xmlrpclib.ServerProxy("%s/openerp-synchro.php" % website.url)
        print server
        extra_fields = server.get_products_extra_fields_values(info_prod['products_id'])
        print extra_fields
        for extra_field in extra_fields:
            fname = esale_extra_fields_obj.search(cr, uid, [('web_id','=',website.id), ('esale_oscom_id', '=', extra_field[1])])
            value = {
                'name': fname,
                'web_id' : website.id,
                'products_id' : prod_id,
                'extra_field_id': fname[0],
                'extra_fields_value' : extra_field[2],
             }
            print extra_field
            print extra_field[0]
            existing = esale_products_extra_fields_obj.search(cr, uid, [('web_id','=',website.id), ('products_id', '=', prod_id), ('extra_field_id', '=', fname[0])])
            if len(existing) > 0:
                print "Existe valor campos extra", existing
                esale_products_extra_fields_obj.write(cr, uid, existing, value)
            else:
                print "NO Existe valor campos extra", existing
                esale_products_extra_fields_obj.create(cr, uid, value)
        return True

    _columns = {
        'extra_field_ids': fields.one2many('esale.oscom.extra_fields', 'web_id', 'Product extra fields'),
    }
esale_oscom_web()

class esale_oscom_product_inherit(osv.osv):
    _inherit = 'product.product'

    def product_extra_info_extra_fields(self, cr, uid, website, esale_product):
        print "Updateando Campos extra en Tienda"
        server = xmlrpclib.ServerProxy("%s/openerp-synchro.php" % website.url)

        esale_products_extra_fields_obj = self.pool.get('esale.oscom.product.extra_fields_values')
        print "Obteniendo prod_id de producto", esale_product.product_id.id

        fname_ids = esale_products_extra_fields_obj.search(cr, uid, [('web_id','=',website.id), ('products_id', '=', esale_product.product_id.id)])
        print "Obteniendo ids registros de valores", fname_ids

        fnames = esale_products_extra_fields_obj.browse(cr, uid, fname_ids)
        print "Obteniendo registros de valores", fnames
        for fname in fnames:
            value = {
                    'products_id' : esale_product.esale_oscom_id,
                    'extra_field_id': fname.extra_field_id.esale_oscom_id,
                    'extra_fields_value' : fname.extra_fields_value,
                 }
            print value

            server.set_products_extra_fields_values(esale_product.esale_oscom_id, value)
        return True

esale_oscom_product_inherit()



